* -*- mode:Mail -*-

        TITLE Repertoire d'installation pour SX

*  (c) 02/1998 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the ERABLE package.
*  See copying.doc for licensing information

INCLUDE erromid.h
INCLUDE kromid.h
INCLUDE erextdec.h
INCLUDE kextdec.h
INCLUDE keydefs.h
INCLUDE khash.h
INCLUDE erhash.h

*
* Rpertoire ALGB d'installation
* Ne pas oublier de modifier le checksum dans INIT
*

ASSEMBLE
        NIBASC /HPHP48-D/
RPL
ASSEMBLE
            CON(5) #02A96 ( DORRP )
            CON(3) #7FF   ( NO LIB attached )
debut       CON(5) (dernier)-(debut)
            CON(5) #00000 ( le premier objet suit )



*******************************************************************
***************     GETALL
            CON(2) ((GETALLfin)-(GETALLdeb))/2
GETALLdeb   NIBASC /GETALL/
GETALLfin   CON(2) ((GETALLfin)-(GETALLdeb))/2
RPL
::
xHOME { ID other ID crypt ID decrypt ID fr ID us  }
DUP xKGET xORDER
;
ASSEMBLE
GETALL      CON(5) (GETALL)-(GETALLdeb)+2
***************    GETALL
*******************************************************************


*******************************************************************
***************     SENDIR
            CON(2) ((SENDIRfin)-(SENDIRdeb))/2
SENDIRdeb   NIBASC /SENDIR/
SENDIRfin   CON(2) ((SENDIRfin)-(SENDIRdeb))/2
RPL
::
{ LAM erable.lib LAM KERNEL.LIB LAM SXKEYS }
DOBINT ALROMID UNCOERCE "&" >TAG xRCL
DOBINT KROMID UNCOERCE "&" >TAG xRCL
xRCLKEYS
4PICK BIND xSEND
ABND
;
ASSEMBLE
SENDIR      CON(5) (SENDIR)-(SENDIRdeb)+2
***************    SENDIR
*******************************************************************

*******************************************************************
***************     SETFR
            CON(2) ((SETFRfin)-(SETFRdeb))/2
SETFRdeb   NIBASC /SETFR/
SETFRfin   CON(2) ((SETFRfin)-(SETFRdeb))/2
RPL
::
x\<<
{ HXS 10 0FF01048C8300003
  HXS 10 00C7010000000028
  }
xSTOF
x\>>
;
ASSEMBLE
SETFR      CON(5) (SETFR)-(SETFRdeb)+2
***************    SETFR
*******************************************************************


*******************************************************************
***************     PURG
            CON(2) ((PURGfin)-(PURGdeb))/2
PURGdeb   NIBASC /PURG/
PURGfin   CON(2) ((PURGfin)-(PURGdeb))/2
RPL
::
xHOME ' ID algb xPGDIR
;
ASSEMBLE
PURG      CON(5) (PURG)-(PURGdeb)+2
***************    PURG
*******************************************************************



*********************************************************************
*************     INIT
dernier     CON(2) ((INITfin)-(INITdeb))/2
INITdeb     NIBASC /INIT/
INITfin     CON(2) ((INITfin)-(INITdeb))/2
RPL
::
' VERNUMext ROMPTR@
ITE :: VERSION% %= ;
    FALSE
NOTcase :: HOMEDIR
	   TAG & % 787 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
	   TAG & % 788 DUP xDETACH ERRSET xPURGE ERRTRAP DROP
	   BlankDA12
           xMEM  % 100000 %-
           DUP %0<
           case :: %CHS DO>STR " bytes" &$
                   "Lack of " SWAP &$ FlashWarning
                   DROP ;
           DROP
           "Installing erable.lib,"
           DISPROW2
           "Your HP will warmstart"
           DISPROW3
           "After the warmstart,"
           DISPROW4
           "type algb and INIT"
           DISPROW5
           ' ID erable.lib DUPDUP xKGET
           @ DROPSWAP PURGE %0 xSTO
           ' ID KERNEL.LIB DUPDUP xKGET
           @ DROPSWAP PURGE %0 xSTO
	   ' ID SXKEYS xKGET
           CODE
               GOVLNG =Warmstart
               ENDCODE
           ;
xMEM  % 5000 %-
DUP %0<
case :: %CHS DO>STR " bytes" &$
        "Lack of " SWAP &$ FlashWarning
        DROP ;
DROP CONTEXT@ xVER DROP CONTEXT!
BlankDA12
"Assigning USERKeys" DISPROW2
' ID SXKEYS xRCL EVAL palparse DROP xSTOKEYS
"Compressing..." DISPROW3
' ID UserKeys DUP RclHiddenVar DROP
* remplace les { } par des NULL{}
' :: DUPTYPELIST? NOT?SEMI
     DUPNULL{}? casedrop NULL{}
     INNERDUP
     ZERO_DO
            DUP #1+ROLL 1GETLAM EVAL
            SWAPLOOP
     {}N
     ;
DUP1LAMBIND EVAL
( UserKeys, contenu )
DUP xBYTES DROP ' ID UserKeys.CRC
StoHiddenVar SWAP StoHiddenVar
"Done." DISPROW4
ONE SetUserFlag SETQext
( WarmStart )
CODE
    GOVLNG =Warmstart
    ENDCODE
;
* ASSEMBLE
* INIT        CON(5) (INIT)-(INITdeb)+2
*****************  INIT
*********************************************************************
