* -*- mode:Mail -*-

	STITLE Erable External Declarations

*  (c) 07/1998 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the ERABLE package.
*  See copying.doc for licensing information

*******************************************************************
*   ERBALE Library external declarations file.  This file should  *
*   be included in all source modules.                            *
*******************************************************************
********************
*   Noms visbles   *
********************
* page 1
EXTERNAL xXY
EXTERNAL xidn
EXTERNAL xTRAN
EXTERNAL xTR
EXTERNAL xMAD
EXTERNAL xrref
* page 2
EXTERNAL xGCD1
EXTERNAL xLCM1
EXTERNAL xSIMP2
EXTERNAL xDIVIS
EXTERNAL xLGCD
EXTERNAL xGCD3
* page 3
EXTERNAL xFCOEF
EXTERNAL xSQRT
EXTERNAL xCOLC
EXTERNAL xEXPA
EXTERNAL xFACTO
EXTERNAL xFROOTS
* page 4
EXTERNAL xAXL
EXTERNAL x?
EXTERNAL xabs
EXTERNAL xXNUM
EXTERNAL xXQ
EXTERNAL xarg
* page 5
EXTERNAL xLVAR
EXTERNAL xMMULT
EXTERNAL xEPSX0
EXTERNAL xre
EXTERNAL xim
EXTERNAL xconj
* page 6
EXTERNAL xFXND
EXTERNAL xNDXF
EXTERNAL xPF
EXTERNAL xEXEC
EXTERNAL xPFEXEC
EXTERNAL xEXPLIN
* page 7
EXTERNAL xPTAYL
EXTERNAL xDIV1
EXTERNAL xHORN
EXTERNAL xLU2
EXTERNAL xder
EXTERNAL xRISCH
* page 8
EXTERNAL xadd
EXTERNAL xSUBT
EXTERNAL xMULT
EXTERNAL xDIV2
EXTERNAL xPOWER
EXTERNAL xCHS
* page 9
EXTERNAL xVER
EXTERNAL xLIDNT
EXTERNAL xLCXM
EXTERNAL xcross
EXTERNAL xTRIGSIN
EXTERNAL xPCAR
* page 10
EXTERNAL xdet
EXTERNAL xLIMIT
EXTERNAL xder1
EXTERNAL xRANG
EXTERNAL xRDET
EXTERNAL xINVL
* page 11
EXTERNAL xSYST
EXTERNAL xSOLGEN
EXTERNAL xJORDAN
EXTERNAL xTRIG
EXTERNAL xTRIGLIN
EXTERNAL xLDEC
* page 12
EXTERNAL xPREVAL
EXTERNAL xORND
EXTERNAL xEULER
EXTERNAL xfact
EXTERNAL xcomb
EXTERNAL xABCUV
* page 13
EXTERNAL xTAN2SC
EXTERNAL xLEGENDRE
EXTERNAL xTCHEB
EXTERNAL xHERMITE
EXTERNAL xHILBERT
EXTERNAL xVAND
* page 14
EXTERNAL xSERIES
EXTERNAL xQXA
EXTERNAL xAXQ
EXTERNAL xILAP
EXTERNAL xKERN
EXTERNAL xCIRC
* page 15
EXTERNAL xC2P
EXTERNAL xP2C
EXTERNAL xDSOLVE
EXTERNAL xTSIMP
EXTERNAL xLAP
EXTERNAL xHALFTAN
* page 16
EXTERNAL xIPP
EXTERNAL x\9F
EXTERNAL xDIV
EXTERNAL xCURL
EXTERNAL xLAPL
EXTERNAL xHESS
* page 17
EXTERNAL xNORM
EXTERNAL xSINCOS
EXTERNAL xTAN2SC2
EXTERNAL xTRIGCOS
EXTERNAL xTEXPA
EXTERNAL xTRUNC
* page 18
EXTERNAL xDIVPC
EXTERNAL xLNCOLC
EXTERNAL xSOLV
EXTERNAL xEXPLN
EXTERNAL xSCROLL
EXTERNAL xFSIGN

EXTERNAL VERNUMext  ( -> % )
* renvoie le numro de version
EXTERNAL LXAext  ( liste -> array )
* Transforme 1 liste (niveau 1) en tableau (si possible)
EXTERNAL EGCDext ( a, b -> d, u, v t.q. d=pgcd[a,b], au+bv=d )
* identit de Bezout 
EXTERNAL MONOEVALext  ( o # [op du runstream] -> op[o] )
* pour un operateur op unaire
EXTERNAL ELMGext ( obj -> obj )
* Remplace par 0 les reels inferieurs a epsilon
EXTERNAL DIVISext   ( objet -> liste des diviseurs )
EXTERNAL RACPOLext  ( liste de racines ou de facteurs -> polynome ou entier )
* Inverse de RFACText. Si le UserFlag 10 est arme, il s'agit de facteurs
* entiers, sinon de racines.
EXTERNAL FACT1ext ( polynome -> lvar, poly-liste, {liste des racines} )
* Factorise un polynome, renvoie le coefficient dominant
* et la liste des racines.
EXTERNAL FACTOext  
( polynome ou entier -> lvar, poly-liste, liste des facteurs )
EXTERNAL SOLVext   ( polynome-liste -> liste des racines )
( ou polynome-liste, epsilon, nombre d'iterations -> liste des racines )
* Factorise un polynome-liste a coeffcients reels ou complexes
* par la methode de Laguerre ou de Bairstow.
EXTERNAL EVIDENText  ( polynome-liste -> liste de racines, reste du poly )
* Recherche les racines rationnelles d'un polynome (permet aussi de
* factoriser certains polynomes a coefficients formels)
EXTERNAL DEG2ext  ( polynome-liste de degre < 3 -> liste des racines )
* Factorisation d'un polynome de degre 2 (eventuellement formel)
EXTERNAL PIext ( liste -> produit des elements de liste )
EXTERNAL asopext
* appelle BINEVALext apres test des profondeurs des 2 objets
EXTERNAL INTEGRext  ( polynome-liste -> primitive )
* calcule la primitive s'annulant en 0
EXTERNAL LRDMext    ( liste entier -> liste )
* Rajoute des 0 a gauche pour obtenir un polynome "de degre" egal a
* l'entier specifie (entier est un reel ou un binaire)
EXTERNAL RRDMext    ( liste entier -> liste )
* Comme LRDM mais cree des zeros a droite
EXTERNAL DEGREext   ( objet -> degre )
* renvoie le degre d'un polynome-liste
EXTERNAL COMPRIMext ( liste -> liste comprimee au sens ensembliste )
EXTERNAL QOBJext    ( objet [runstream: programme] -> objet )
* Exexute programme par 'REVAL sur les elements de objet (pour des objets
* de type liste, algebrique ou array en les decomposant)
EXTERNAL LVARext    ( objet -> objet, liste des identificateurs globaux )
EXTERNAL VALext     ( P, x -> P[x] ou P, { x1,..., xn } -> P[x1,...,xn] )
* Note: VALext met internalflag a 0 avant d'appeler VALOBJext
EXTERNAL TRLPGCDext
* TRIMext suivi de LPGCDext
EXTERNAL SIMP1ext ( symb -> symb simplifie )
EXTERNAL NUMEVALext ( evalue l'objet suivant du runstream en mode num )
EXTERNAL MENUext ( $6 $5 $4 $3 $2 $1 -> affichage du menu )
* Affiche les 6 chanes dans les 6 cases du menu
EXTERNAL SYMCOMPext ( obj -> sym, idnt ou lam )
EXTERNAL XYext      ( vecteur x et y -> x.y produit scalaire )
EXTERNAL CK2FPOLY ( -> )
* teste les niveaux 1 et 2 de la pile, si une liste vide est rencontree
* provoque une erreur
EXTERNAL MEVALext   ( objet, l1, l2 -> objet )
* obj, l1, l2 -> obj': remplace dans obj les elements de l1 par ceux de l2
EXTERNAL PTAYLext   ( polynme-liste P, r -> dvpt Taylor de P en r )
EXTERNAL TOLISText  ( o1, ..., on, #n -> lvar, l-o1,..., l-on )
* conversion au format interne de plusieurs objets selon flag 17
EXTERNAL LISTOPext ( -> liste d'operateurs )
EXTERNAL SETQext ( -> )
* place en mode symbolique
EXTERNAL REDLIBext ( # -> 3 ou 5 programmes )
*( rappelle sur la pile selon la valeur de stk1 )
*( #0: PIVOT, EXL, ELEM )
*( #1: PIVOT, EXL, ELEM, XRED, LDISP,  )
*( Bind 6     5    4     3      2     1 )
EXTERNAL PIVOText
EXTERNAL EXLext
EXTERNAL ELEMext
EXTERNAL XREDext
EXTERNAL INXREDext
EXTERNAL LDISPext
EXTERNAL VALOBJext ( #depth, poly-liste, { x1 ... xn } -> poly-symb )
* appelle SLVARext pour simplifier la liste de variables puis VAL2
* Note: si internalflag est Set, la conversion n'a pas lieu
EXTERNAL VXLVARext ( symb -> oldvx, symb, lvar )
* identique a LVAR mais en positionnant le contenu de VX en tete,
* si VX n'est pas present, modifie le contenu de VX
EXTERNAL VXTOPext ( lvar -> lvar )
* place le contenu de vx en tete de lvar
EXTERNAL RACTOFACext
* transforme une liste de racines en liste de facteurs
* contrairement a RACPOL, ici il s'agit de { rac rac rac ... }
* et pas de { rac mul rac mul ... }
EXTERNAL LOP1ext ( liste, obj, prg -> liste )
* { o1, ..., on }, obj, prg -> { prg[o1,obj], ..., prg[on, obj] }
EXTERNAL FROMLISText
* lvar, obj1,..., objn, {#prof1, ..., #profn} -> obj1, ..., objn
* contraire de TOLISText
EXTERNAL MVMULText ( matrice, vecteur -> vecteur )
* produit
EXTERNAL DMONOEVALext
* appelle MONOEVALext avec comme profondeur celle de l'objet
EXTERNAL BINEVALext ( o1, o2, #prof [operande du runstream] -> o1 operande o2 )
* effectue EVAL mais en representation liste
EXTERNAL BIN2EVALext ( o1, o2, [ procedure du runstream] -> o1', o2' )
EXTERNAL LLVARDext ( o -> #depth, o, lvar )
* liste des identificateurs, racines carrees considerees comme op arithmetique
EXTERNAL SLVARext ( lvar -> lvar )
* simplifie la liste des variables selon le flag recurseflag
EXTERNAL FACT2MULText ( listnum, listdeno -> list )
* listnum et listdeno representent des listes de facteurs au numerateur et au
* denominateur,
* on regroupe les facteurs sous la forme facteur multiplicite
* Exemple { 2 2 3 4 } { 3 3 3 5 5 } -> { 4 1 2 2 3 -2 5 -2 }
* l'algo n'est pas terrible, on extrait tous les facteurs du numerateur
* avec NEXTP, on regarde comment ils sont au denominateur
EXTERNAL VPMULText ( vecteur, scalaire -> vecteur )
* Produit vecteur * scalaire
EXTERNAL MULMULText ( liste, coeff -> liste )
* multiplie les multiplicites dans liste par coeff
EXTERNAL ADDLISText ( liste, multiplicite, objet -> liste )
* ajoute un objet ayant une multiplicite a une liste
* d'objets-multiplicite
EXTERNAL COMPLISText ( liste -> liste )
* additionne les multiplicites et supprime les facteurs multiples
* de la liste
EXTERNAL SQFF2ext ( l1, ..., ln, #n -> l1', ..., ln', #n)
* teste s'il y a des pgcd non triviaux entre les facteurs des lj
* pour renvoyer une liste de facteurs premiers entre eux
EXTERNAL RFACText ( obj, # -> lvar, obj interne, liste fact/rac )
* Factorisation rationnelle selon #
EXTERNAL RFACT2ext ( obj, lvar, # -> lvar, obj, lrac | lfac )
* Comme le precedent mais avec lvar precise
EXTERNAL FACTOBJext ( lfact, #, flag -> lfact ou lrac )
* voir dans alsubs.h
EXTERNAL FACTOOBJext ( inverse de RFACText )
* Si flag est TRUE on a affaire a des facteurs, sinon a des racines
EXTERNAL DERIVext ( symb -> derivee )
EXTERNAL xvext
EXTERNAL xEXPext
EXTERNAL xINVext
EXTERNAL xSQext
EXTERNAL xCOSext
EXTERNAL xSINext
EXTERNAL xTANext
EXTERNAL xCOSHext
EXTERNAL xSINHext
EXTERNAL xTANHext
EXTERNAL xLNext
EXTERNAL xLN3ext
EXTERNAL ISOLext ( symb, idnt -> symb )
* comme la fonction user ISOL
EXTERNAL LIDNText ( obj -> liste des idnt )
* EXTERNAL 13SIMP1ext ( o -> o simplifie )
* appelle SIMP1ext si le flag 13 est desarme
EXTERNAL HSECO2RCext
* symb -> symb: interne -> externe
EXTERNAL RMSYMext
* symb -> symb: externe -> interne
EXTERNAL RISCHext ( symb -> primitive symbolique )
EXTERNAL LVARXNXext ( symb -> symb, x, lvarnx, lvarx )
EXTERNAL LVARXNX2ext ( symb, listop -> symb, x, lvarnx, lvarx )
EXTERNAL DEText ( matrice symbolique -> determinant )
* algorithme stupide
EXTERNAL LIFCext 
EXTERNAL RLVARext ( recursive LVAR )
EXTERNAL QXAext ( symb -> matrice de forme quadratique )
EXTERNAL CKPERMext ( list -> liste, teste si on a affaire a une permutation )
EXTERNAL CIRCext ( compose 2 permutations liste )
EXTERNAL P2Cext ( decomposition en cycles )
EXTERNAL C2Pext ( cycles -> permutation )
EXTERNAL TSIMP2ext ( comme TSIMP sans EXPLN et sans simplifier les LN )
EXTERNAL TSIMPext ( simpl. transcendante )
EXTERNAL TSIMP3ext ( routine commune aux TSIMP )
EXTERNAL ONE{}Next ( augmente la profondeur d'un objet d'1 niveau )
EXTERNAL EXPLNext ( transforme tout en exp et ln )
EXTERNAL SINCOSext ( exp et ln en exp/sin/cos et ln/atan )
EXTERNAL LNATANext ( log d'une expression: partie reelle et imaginaire )
EXTERNAL ARGext ( im, re -> argument d'une expression )
EXTERNAL QUADRANText
EXTERNAL xATANext
EXTERNAL TAN2SC2ext
EXTERNAL COLCext ( version interne de COLC )
EXTERNAL LCXMext ( #, #, prg -> matrice )
EXTERNAL SYSText
( matrice, linconnues -> linconnues, linconnues rearrangee, result, cas part )
EXTERNAL MDIAGext ( matr -> diag )
* extrait les coefs diagonaux
EXTERNAL SOLGENext
EXTERNAL STOSYSText ( matrice, linconnues -> matrice, linconnues )
* stocke le systeme si la matrice a des variables
EXTERNAL RDEText ( matr -> determinant )
EXTERNAL INVLext ( matr -> cas part, inverse )
EXTERNAL PREVALext ( alg, inf, sup -> alg[sup]-alg[inf] )
EXTERNAL INText ( f[x], x -> int[x0,x,f[xt],xt] )
EXTERNAL LINSOLVext ( { b a } -> y t.q. y'=ay+b )
EXTERNAL DSOLVTAGext ( res, y, type -> :y-y0: res )
EXTERNAL SEPARext ( deno -> deno, [ deno-y, deno-x, TRUE | FALSE ] )
EXTERNAL SIGMAEXPext ( symb -> symb, TRUE ou FALSE )
* renvoie TRUE si symb peut s'ecrire comme somme d'exponentielles 
EXTERNAL LINEXPext ( symb -> liste pole/coeff, TRUE / FALSE )
* teste si un symb est une somme d'exponentielles * polynome en vx
EXTERNAL EGCD?ext ( appelle EGCD ou IEGCD selon flag integerflag )
EXTERNAL ID>DERext ( idnt -> liste des derivees, stripped idnt )
EXTERNAL RTCOMPext ( obj, fnc1, fnc2 -> fnc1[obj], teste fnc2 )
EXTERNAL HORNext    ( polynome-liste P, r -> P[X] div [X-r], r, P[r] )
EXTERNAL xASINext
EXTERNAL xACOSext
EXTERNAL SIN2ext
EXTERNAL COS2ext
EXTERNAL STOMAText
EXTERNAL SINH2EXPext
EXTERNAL COSH2EXPext
EXTERNAL TANH2EXPext
EXTERNAL ASINH2LNext
EXTERNAL ACOSH2LNext
EXTERNAL ATANH2LNext
EXTERNAL POW2EXPLNext
EXTERNAL XROOT2ext
EXTERNAL LN2ext
EXTERNAL INFINIext
EXTERNAL ?ext
EXTERNAL TABLECOSext
EXTERNAL TABLETANext
EXTERNAL xSINCOSext
EXTERNAL PFext
EXTERNAL TRIGext
EXTERNAL TEXPA?
EXTERNAL TCHEBext
EXTERNAL SINEXPA
EXTERNAL SINEXPA1
EXTERNAL COSEXPA
EXTERNAL COSEXPA1
EXTERNAL TAN2SCext
EXTERNAL EXPEXPA
EXTERNAL SIN2TCext
EXTERNAL RTCOMP2ext
EXTERNAL LNEXPA?
EXTERNAL LNEXPA
EXTERNAL LAPext
EXTERNAL LINEXPA
EXTERNAL PFEXECext
EXTERNAL VXXLFext
EXTERNAL LNCOLCext
EXTERNAL ISOL2ext
EXTERNAL HYP2EXPext
EXTERNAL TEXPAext
EXTERNAL ATAN2LNext
EXTERNAL TAN2SC2
EXTERNAL SIN2LNext
EXTERNAL COS2LNext
EXTERNAL SPECIALext
EXTERNAL LIMIText
EXTERNAL MAKESYSText
EXTERNAL SCROLLext
EXTERNAL VARGENext
